LuminanceSource (ZXing 3.5.0 API)

com.google.zxing

## Class LuminanceSource

- java.lang.Object
- - com.google.zxing.LuminanceSource

- Direct Known Subclasses:
    BufferedImageLuminanceSource, InvertedLuminanceSource, PlanarYUVLuminanceSource, RGBLuminanceSource

      public abstract class LuminanceSource
      extends Object

  The purpose of this class hierarchy is to abstract different bitmap implementations across platforms into a standard interface for requesting greyscale luminance values. The interface only provides immutable methods; therefore crop and rotation create copies. This is to ensure that one Reader does not modify the original luminance source and leave it in an unknown state for other Readers in the chain.
  Author:
    dswitkin@google.com (Daniel Switkin)

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `LuminanceSource(int width, int height)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `LuminanceSource` | `crop(int left, int top, int width, int height)` Returns a new object with cropped image data.
    `int` | `getHeight()`
    `abstract byte[]` | `getMatrix()` Fetches luminance data for the underlying bitmap.
    `abstract byte[]` | `getRow(int y, byte[] row)` Fetches one row of luminance data from the underlying platform's bitmap.
    `int` | `getWidth()`
    `LuminanceSource` | `invert()`
    `boolean` | `isCropSupported()`
    `boolean` | `isRotateSupported()`
    `LuminanceSource` | `rotateCounterClockwise()` Returns a new object with rotated image data by 90 degrees counterclockwise.
    `LuminanceSource` | `rotateCounterClockwise45()` Returns a new object with rotated image data by 45 degrees counterclockwise.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### LuminanceSource

          protected LuminanceSource(int width,
                                    int height)

  - ### Method Detail

    - #### getRow

          public abstract byte[] getRow(int y,
                                        byte[] row)

      Fetches one row of luminance data from the underlying platform's bitmap. Values range from 0 (black) to 255 (white). Because Java does not have an unsigned byte type, callers will have to bitwise and with 0xff for each value. It is preferable for implementations of this method to only fetch this row rather than the whole image, since no 2D Readers may be installed and getMatrix() may never be called.
      Parameters:
        `y` - The row to fetch, which must be in [0,getHeight())
        `row` - An optional preallocated array. If null or too small, it will be ignored. Always use the returned object, and ignore the .length of the array.
      Returns:
        An array containing the luminance data.

    - #### getMatrix

          public abstract byte[] getMatrix()

      Fetches luminance data for the underlying bitmap. Values should be fetched using: `int luminance = array[y * width + x] & 0xff`
      Returns:
        A row-major 2D array of luminance values. Do not use result.length as it may be larger than width * height bytes on some platforms. Do not modify the contents of the result.

    - #### getWidth

          public final int getWidth()

      Returns:
        The width of the bitmap.

    - #### getHeight

          public final int getHeight()

      Returns:
        The height of the bitmap.

    - #### isCropSupported

          public boolean isCropSupported()

      Returns:
        Whether this subclass supports cropping.

    - #### crop

          public LuminanceSource crop(int left,
                                      int top,
                                      int width,
                                      int height)

      Returns a new object with cropped image data. Implementations may keep a reference to the original data rather than a copy. Only callable if isCropSupported() is true.
      Parameters:
        `left` - The left coordinate, which must be in [0,getWidth())
        `top` - The top coordinate, which must be in [0,getHeight())
        `width` - The width of the rectangle to crop.
        `height` - The height of the rectangle to crop.
      Returns:
        A cropped version of this object.

    - #### isRotateSupported

          public boolean isRotateSupported()

      Returns:
        Whether this subclass supports counter-clockwise rotation.

    - #### invert

          public LuminanceSource invert()

      Returns:
        a wrapper of this `LuminanceSource` which inverts the luminances it returns -- black becomes white and vice versa, and each value becomes (255-value).

    - #### rotateCounterClockwise

          public LuminanceSource rotateCounterClockwise()

      Returns a new object with rotated image data by 90 degrees counterclockwise. Only callable if `isRotateSupported()` is true.
      Returns:
        A rotated version of this object.

    - #### rotateCounterClockwise45

          public LuminanceSource rotateCounterClockwise45()

      Returns a new object with rotated image data by 45 degrees counterclockwise. Only callable if `isRotateSupported()` is true.
      Returns:
        A rotated version of this object.

    - #### toString

          public final String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2007–2022. All rights reserved.